import Docxtemplater from 'docxtemplater'
import PizZip from 'pizzip'
import { getNowDate } from './Date';
import { GetTime } from './Date';
import FileSaver, { saveAs } from 'file-saver';
import JSZipUtils from 'jszip-utils'
import html2canvas from 'html2canvas'
import ImageModule from 'docxtemplater-image-module-free'

// 新学生创业项目申请表下载模板word版
function getWord2(val){
    JSZipUtils.getBinaryContent('./file/2023年学生创客项目申报书模板 - 副本.docx',async (err,content)=>{
        if (err) {
            return console.log(err);
        }

				let ImageList = await getImage(val.elementList);

				// console.log(ImageList.find(i=>i.tagName=='back').url)
				// return console.log(ImageList)

        let zip=new PizZip(content);

				// 图片处理
				const opts = {
					centered:false,
					fileType:"docx",
					getImage:(value,value2,value3)=>{
						return base64DataURLToArrayBuffer(value)
					},
					getSize:(arrayValue,value,tagName)=>{
						let imgObj = ImageList.find(i=>i.tagName==tagName) 
						let newWidth = 550;
						let newHeight = (newWidth*imgObj.height)/imgObj.width;
						return [newWidth,newHeight]
					}
				}
				let doc=new Docxtemplater()
				doc.loadZip(zip);

				doc.attachModule(new ImageModule(opts));
        // return console.log(val);

        // let FundAll=
        // return console.log(val);

        //填写数据
        doc.setData({
            nowTime:getNowDate(1),//申请日期
            projectName:val.projectName,
            ing:val.radio=='ed917c55-f51d-11ed-a3f6-509a4c5b67cf'?'√':'□',
            ed:val.radio=='f3068e26-f51d-11ed-a3f6-509a4c5b67cf'?'√':'□',
            mone:val.checkList.includes('1')?'√':'□',
            mtwo:val.checkList.includes('2')?'√':'□',
            mthree:val.checkList.includes('3')?'√':'□',
            mfour:val.checkList.includes('4')?'√':'□',
            sone:val.schoolRadio.includes('1')?'√':'□',
            stwo:val.schoolRadio.includes('2')?'√':'□',
            sthree:val.schoolRadio.includes('3')?'√':'□',
            sfour:val.schoolRadio.includes('4')?'√':'□',
            stu:val.applyParsonRadio.includes('1')?'√':'□',
            leg:val.applyParsonRadio.includes('2')?'√':'□',
            appPeason:val.applyParsonName,
            school:val.dp,
            tel:val.tel,
            begin_at:val.btime,
            plannedEnd_at:val.etime,
            allnum:val.studentS.length+val.teacherS.length,
            snum:val.studentS.length,
            tnum:val.teacherS.length,
            student:val.studentS,
            teacher:val.teacherS,
            brief:val.brief,
            back:ImageList.find(i=>i.tagName=='back').url,
            innovate:ImageList.find(i=>i.tagName=='innovate').url,
            path:ImageList.find(i=>i.tagName=='path').url,
            scene:ImageList.find(i=>i.tagName=='scene').url,
            worth:ImageList.find(i=>i.tagName=='worth').url,
            team:ImageList.find(i=>i.tagName=='team').url,
            cost:ImageList.find(i=>i.tagName=='cost').url,
            expectResults:ImageList.find(i=>i.tagName=='expectResults').url,
            expectResultsTeacher:ImageList.find(i=>i.tagName=='expectResultsTeacher').url,
            expectConversion:ImageList.find(i=>i.tagName=='expectConversion').url,
            plan:ImageList.find(i=>i.tagName=='plan').url,
						total:0,
            facility:0,
            materials:0,
            process:0,
            assist:0,
            authenticate:0,
            match:0,
            activity:0,
            affair:0,
						total:val.fund.device*1 + val.fund.Material*1+val.fund.processing*1+ val.fund.Collaboration*1+val.fund.APPRAISAL*1+ val.fund.entery*1+val.fund.activities*1+val.fund.Transaction*1,
            facility:val.fund.device,
            materials:val.fund.Material,
            process:val.fund.processing,
            assist:val.fund.Collaboration,
            authenticate:val.fund.APPRAISAL,
            match:val.fund.entery,
            activity:val.fund.activities,
            affair:val.fund.Transaction,
        })

        // 进行填充
        doc.render()

        let out=doc.getZip().generate({
            type:'blob',
            mimeType:"application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        })

        // fs.writeFileSync(path.resolve(__dirname, "output.docx"), buf);
        saveAs(out,'2023年学生创客项目申报书.docx')

    })
}

function getImage(elList){
	return new Promise(async (resolve)=>{
		let imgList=[]
		elList.forEach(async el=>{
		  let imgObj = {tagName:"",url:"",width:0,height:0}
		  imgObj.tagName=el.getAttribute("tag");
		  let canvas = await html2canvas(el,{
				allowTaint:true,
				useCORS:true,
				scale:2
			})
			imgObj.url = canvas.toDataURL('image/png');
			imgObj.width = canvas.width;
			imgObj.height = canvas.height;
			imgList.push(imgObj)
			if(imgList.length==elList.length){
				resolve(imgList)
			}
		})
	})
}

// 

function base64DataURLToArrayBuffer(dataURL) {
  const base64Regex = /^data:image\/(png|jpg|svg|svg\+xml);base64,/;
  if (!base64Regex.test(dataURL)) {
    return false;
  }
  const stringBase64 = dataURL.replace(base64Regex, "");
  let binaryString;
  if (typeof window !== "undefined") {
    binaryString = window.atob(stringBase64);
  } else {
    binaryString = new Buffer(stringBase64, "base64").toString("binary");
  }
  const len = binaryString.length;
  const bytes = new Uint8Array(len);
  for (let i = 0; i < len; i++) {
    const ascii = binaryString.charCodeAt(i);
    bytes[i] = ascii;
  }
  return bytes.buffer;
}

export{
    getWord2,
}